#!/bin/sh
export PATH='/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl'
echo 'name: shake
version: 0.16.4
id: shake-0.16.4-CDniocy9r1fEPghGBbQGPr
key: shake-0.16.4-CDniocy9r1fEPghGBbQGPr
license: BSD-3-Clause
copyright: Neil Mitchell 2011-2018
maintainer: Neil Mitchell <ndmitchell@gmail.com>
author: Neil Mitchell <ndmitchell@gmail.com>
homepage: https://shakebuild.com
synopsis: Build system library, like Make, but more accurate dependencies.
description:
    Shake is a Haskell library for writing build systems - designed as a
    replacement for @make@. See "Development.Shake" for an introduction,
    including an example. The homepage contains links to a user
    manual, an academic paper and further information:
    <https://shakebuild.com>
    .
    To use Shake the user writes a Haskell program
    that imports "Development.Shake", defines some build rules, and calls
    the '\''Development.Shake.shakeArgs'\'' function. Thanks to do notation and infix
    operators, a simple Shake build system
    is not too dissimilar from a simple Makefile. However, as build systems
    get more complex, Shake is able to take advantage of the excellent
    abstraction facilities offered by Haskell and easily support much larger
    projects. The Shake library provides all the standard features available in other
    build systems, including automatic parallelism and minimal rebuilds.
    Shake also provides more accurate dependency tracking, including seamless
    support for generated files, and dependencies on system information
    (e.g. compiler version).
category: Development, Shake
abi: 773a0a18f941a26cd2a47be2900385c8
exposed: True
exposed-modules:
    Development.Shake Development.Shake.Classes
    Development.Shake.Command Development.Shake.Config
    Development.Shake.FilePath Development.Shake.Forward
    Development.Shake.Rule Development.Shake.Util
hidden-modules: Development.Ninja.Env Development.Ninja.Lexer
                Development.Ninja.Parse Development.Ninja.Type
                Development.Shake.Internal.Args
                Development.Shake.Internal.CmdOption
                Development.Shake.Internal.Core.Action
                Development.Shake.Internal.Core.Database
                Development.Shake.Internal.Core.Monad
                Development.Shake.Internal.Core.Pool
                Development.Shake.Internal.Core.Rendezvous
                Development.Shake.Internal.Core.Rules
                Development.Shake.Internal.Core.Run
                Development.Shake.Internal.Core.Storage
                Development.Shake.Internal.Core.Types
                Development.Shake.Internal.Demo Development.Shake.Internal.Derived
                Development.Shake.Internal.Errors
                Development.Shake.Internal.FileInfo
                Development.Shake.Internal.FileName
                Development.Shake.Internal.FilePattern
                Development.Shake.Internal.Options Development.Shake.Internal.Paths
                Development.Shake.Internal.Profile
                Development.Shake.Internal.Progress
                Development.Shake.Internal.Resource
                Development.Shake.Internal.Rules.Directory
                Development.Shake.Internal.Rules.File
                Development.Shake.Internal.Rules.Files
                Development.Shake.Internal.Rules.Oracle
                Development.Shake.Internal.Rules.OrderOnly
                Development.Shake.Internal.Rules.Rerun
                Development.Shake.Internal.Shake Development.Shake.Internal.Value
                General.Bag General.Bilist General.Binary General.Chunks
                General.Cleanup General.Concurrent General.Extra General.FileLock
                General.GetOpt General.Ids General.Intern General.ListBuilder
                General.Makefile General.Process General.Template General.Timing
                Paths_shake
import-dirs: /usr/lib/ghc-8.4.2/site-local/shake-0.16.4
library-dirs: /usr/lib/ghc-8.4.2/site-local/shake-0.16.4
dynamic-library-dirs: /usr/lib
data-dir: /usr/share/haskell-shake
hs-libraries: HSshake-0.16.4-CDniocy9r1fEPghGBbQGPr
depends:
    base-4.11.1.0 binary-0.8.5.1 bytestring-0.10.8.2 deepseq-1.4.3.0
    directory-1.3.1.5 extra-1.6.6-6djCwdVouIMLRJUigmsa65 filepath-1.4.2
    hashable-1.2.7.0-KBRKfoLB8Vi3u8lTX7XQlg
    js-flot-0.8.3-Bsjxmw7L5o0BiJSkgBCarQ
    js-jquery-3.3.1-Ffu7ToZlmCKGwlrB5XNyaf
    primitive-0.6.3.0-DaZpcxwJp2TGn8ITSgfI4C process-1.6.3.0
    random-1.1-9LLJAJa4iQFLJiLXBOBXBV time-1.8.0.2 transformers-0.5.5.0
    unordered-containers-0.2.9.0-KdZ4KMfcSgfH94a9qKVvIF
    utf8-string-1.0.1.1-LRSjvSC6FZkKPp48Qszoj8 unix-2.7.2.2
abi-depends: base-4.11.1.0=ecd125f03c784a67b61c9a8f6dd222e4
             binary-0.8.5.1=253349ae905e3b03d89d37316bf920b7
             bytestring-0.10.8.2=c1695cedf0cebf0c12d34c90fb94a65f
             deepseq-1.4.3.0=521dff49867cc7581bb7066827d3f18e
             directory-1.3.1.5=c4ddb2059d4b7fed7d39b1d1bb3bf41d
             extra-1.6.6-6djCwdVouIMLRJUigmsa65=c547526f498bd8320286d57c9fd7aeb3
             filepath-1.4.2=a70b79acbde9ca897bdc5eadf9254ba7
             hashable-1.2.7.0-KBRKfoLB8Vi3u8lTX7XQlg=0e3ad496fde59157bcd6a630b4b29548
             js-flot-0.8.3-Bsjxmw7L5o0BiJSkgBCarQ=efc8a07d70f9d8404ede170c13da66e1
             js-jquery-3.3.1-Ffu7ToZlmCKGwlrB5XNyaf=76174a1abd641b5717411764f78c7d02
             primitive-0.6.3.0-DaZpcxwJp2TGn8ITSgfI4C=16a73b69e52691069991327a53e4d794
             process-1.6.3.0=f742183dfb18804fd4a4a0e3c09be01d
             random-1.1-9LLJAJa4iQFLJiLXBOBXBV=552cb76a5e53a808564c851a382c09ce
             time-1.8.0.2=f5b6d28c2b89a17d60f5dfeda767abd0
             transformers-0.5.5.0=02be5c4dc3fdc926cf1b36bd484a25f8
             unordered-containers-0.2.9.0-KdZ4KMfcSgfH94a9qKVvIF=2ade52955b9fa0964135ae12d3c6ee25
             utf8-string-1.0.1.1-LRSjvSC6FZkKPp48Qszoj8=98c3aed4d9f965690ee596928a6a8eec
             unix-2.7.2.2=52cd75b8c492339f1bc16a6e08d9b9d7
haddock-interfaces: /usr/share/doc/haskell-shake/html/shake.haddock
haddock-html: /usr/share/doc/haskell-shake/html
' | '/usr/bin/ghc-pkg' 'update' '--force' '-' '--global' '--no-user-package-db' "$@"

